<?

class CNTagBuilder extends BaseObject {

var $d_editable;
var $d_mlId;

function CNTagBuilder() {
$this->d_editable = false;
$this->d_mlId = 0;
}

function setEditable($value) {
$this->d_editable = $value;
}

function getEditable() {
return $this->d_editable;
}

function setMlID($id) {
$this->d_mlId = $id;
}

function getMlID() {
return $this->d_mlId;
}

function unsetMlID() {
$this->d_mlId = 0;
}

function buildTagParts($tag, &$baseObj, $code="") {
//                       
 $vals =& $tag->getValues();
if( $vals == NULL ) return NULL;
$varr = $vals->toArray();
$values = $this->mergeToConstruct($varr, $tag->getConstructID());
return $this->generateParts($values, $code, $baseObj);
}

function &mergeToConstruct(&$values, $constructId) {
static $constructValues = array();
static $constructSort = array();
$parts = array();
$false = false;
if (!isset($constructValues[$constructId])) {
$construct =& CNConstructFactory::getConstruct($constructId);
$vals =& $construct->getValues();
$varr = $vals->toArray();
$constructSort[$constructId] = array();
$constructValues[$constructId] = array();
$this->_buildValueHash($varr, $parts, $false, $constructSort[$constructId], $constructValues[$constructId]);
}
//            
 $valueSort = array();
$partValues = array();
$parthash = $this->_buildValueHash($values, $parts, $false, $valueSort, $partValues);
//                                     
 $mergedSort = $valueSort + $constructSort[$constructId];
asort($mergedSort);
//                        
 //             
 $rs = array();
foreach ($mergedSort as $pid=>$sort) {
if (isset($partValues[$pid])) {
$rs[] =& $partValues[$pid];
} else {
$rs[] =& $constructValues[$constructId][$pid];
}
}

return $rs;
}

function generateParts(&$values, $code, &$baseObj) {
//                                               
 $partnames = array();
$parts = array();
$false = false;
$parthash = $this->_buildValueHash($values, $parts, $partnames, $false, $false);

//                         
 $html = array();
foreach($parthash as $key=>$pid) {
$html[$key] = $this->_buildCode($values[$key], $parts[$pid], $code, $baseObj);
}

//                      
 $out = new CNPartCodeCollection();
$out->setNames($partnames);
foreach($parthash as $key=>$pid) {
$out->addPart($key, $html[$key], $parts[$pid]->isVisible());
}
return $out;
}

function _buildValueHash(&$values, &$parts, &$partnames, &$partorder, &$partvalues) {
$parthash = array();
foreach ($values as $key=>$val) {
$pid = $values[$key]->getPartID();
if (!isset($parts[$pid])) {
$parts[$pid] =& CNPartFactory::getPart($pid);
}
//                 
 $ml = $parts[$pid]->getMlID();
if ($ml && $ml != $this->d_mlId) continue;
$parthash[$key] = $pid;
if (is_array($partnames) && $keyname = $parts[$pid]->getKeyname()) 
$partnames[$keyname] = $key;
if (is_array($partorder)) 
$partorder[$pid] = $parts[$pid]->getPartOrder();
if (is_array($partvalues)) 
$partvalues[$pid] =& $values[$key];
}
return $parthash;
}

function _buildCode(&$value, &$part, $code, &$baseObj) {
$parttype =& CNPartTypeFactory::getPartType($part->getPartTypeID());
return $parttype->buildCode($value, $code, $baseObj);
}
}

class CNPartCodeCollection extends BaseObject {

var $parts;
var $visible;
var $names;

function CNPartCodeCollection() {
$this->parts = array();
$this->visible = array();
$this->names = array();
}

function setNames($names) {
$this->names = $names;
}

function getPropertyNames()
{
$ret = array();
foreach ( $this->names as $name=>$key )
{
$ret[$name] = $name; 
}
return $ret;
}

function& getProperty($key)
{
$obj = false;
$key = strtolower($key);
if ( isset( $this->names[$key] ) )
{
$obj =& $this->parts[$this->names[$key]];
}
else
{
return new NodeException( "CNPartCodeCollection: property ($key) not defined!" );
}
return $obj;

}

function addPart($key, $part, $visible = true) {
$this->parts[$key] = $part;
$this->visible[$key] = $visible;
}

function buildPartCode(&$baseObj, $editMode, $part = false) {
global $TAG_PREFIX;

$html = array();
$names = $this->names;
foreach ($this->parts as $key=>$val) {
$html[$key] = $this->parts[$key]->buildCode($editMode);
$props = $this->parts[$key]->getPartProperties();
foreach ($props as $name=>$val) {
$html["props$name"] = $val;
$names[$names[$key].".".$name] = "props$name";
}
}
$out = "";
if ($part) {	
$out = $html[$names[$part]];
} else {
foreach ($html as $key=>$code) {
if ($this->visible[$key]) $out .= $code;
}
}
//                            
 foreach ($names as $name=>$key) {
//                                          
 $out = str_replace("<$TAG_PREFIX $name>",$html[$key], $out);
}
return $out;
}

function toString() {
$null = NULL;
return $this->buildPartCode($null, CN_EM_PUBLISH);
}

}

?>
