<?php
//
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//        //           /       /                                           
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//                                                                         
//
//                                                       
//
//                                                                 
//           
//

require_once(INCLUDE_PATH."/common.php");

class DB_sybase extends DB_common
{
//               

var $connection;
var $phptype, $dbsyntax;
var $prepare_tokens = array();
var $prepare_types = array();

//    
 //                

function DB_sybase()
{
$this->DB_common();
$this->phptype = 'sybase';
$this->dbsyntax = 'sybase';
$this->features = array(
'prepare' => false,
'pconnect' => true,
'transactions' => false,
'limit' => 'emulate'
);
}

//    
 //              

function connect($dsninfo, $persistent = false)
{
if (!DB::assertExtension('sybase') && !DB::assertExtension('sybase_ct'))
return $this->raiseError(DB_ERROR_EXTENSION_NOT_FOUND);

$this->dsn = $dsninfo;
$user = $dsninfo['username'];
$pw   = $dsninfo['password'];

$dbhost = $dsninfo['hostspec'] ? $dsninfo['hostspec'] : 'localhost';
$connect_function = $persistent ? 'sybase_pconnect' : 'sybase_connect';

if ($dbhost && $user && $pw) {
$conn = $connect_function($dbhost, $user, $pw);
} elseif ($dbhost && $user) {
$conn = $connect_function($dbhost, $user);
} elseif ($dbhost) {
$conn = $connect_function($dbhost);
} else {
$conn = $connect_function();
}

if (!$conn) {
return $this->raiseError(DB_ERROR_CONNECT_FAILED);
}

if ($dsninfo['database']) {
if (!@sybase_select_db($dsninfo['database'], $conn)) {
return $this->raiseError(DB_ERROR_NODBSELECTED);
}
}
$this->connection = $conn;
return DB_OK;
}

//    
 //                 

function disconnect()
{
$ret = @sybase_close($this->connection);
$this->connection = null;
return $ret;
}

//    
 //                  

function simpleQuery($query)
{
$this->last_query = $query;
$query = $this->modifyQuery($query);
$result = @sybase_query($query, $this->connection);
if (!$result) {
return $this->raiseError();
}
//                                                           
 //                                  
 return DB::isManip($query) ? DB_OK : $result;
}

//    
 //                 

/**
     *                                                                     
     *
     *                                     
     *
     *               
     *
     *                                                             
     */
function nextResult($result)
{
return false;
}

//    
 //               
 function &fetchRow($result, $fetchmode = DB_FETCHMODE_DEFAULT, $rownum=null)
{
if ($fetchmode == DB_FETCHMODE_DEFAULT) {
$fetchmode = $this->fetchmode;
}
$res = $this->fetchInto ($result, $arr, $fetchmode, $rownum);
if ($res !== DB_OK) {
return $res;
}
return $arr;
}

//    
 //                

function fetchInto($result, &$ar, $fetchmode, $rownum=null)
{
if ($rownum !== null) {
if (!sybase_data_seek($result, $rownum)) {
return $this->raiseError();
}
}
$ar = ($fetchmode & DB_FETCHMODE_ASSOC) ? @sybase_fetch_array($result) : @sybase_fetch_row($result);
if (!$ar) {
//                                                          
 //                             
 //                                          
 //                                      
 //        
 return null;
// 
 }
return DB_OK;
}

//    
 //                 

function freeResult($result)
{
if (is_resource($result)) {
return @sybase_free_result($result);
}
if (!isset($this->prepare_tokens[(int)$result])) {
return false;
}
unset($this->prepare_tokens[(int)$result]);
unset($this->prepare_types[(int)$result]);
return true;
}

//    
 //              

function numCols($result)
{
$cols = @sybase_num_fields($result);
if (!$cols) {
return $this->raiseError();
}
return $cols;
}

//    
 //                   

/**
     *                                                          
     *                                                    
     *
     *                                                  
     */

function affectedRows()
{
if (DB::isManip($this->last_query)) {
$result = @sybase_affected_rows($this->connection);
} else {
$result = 0;
}
return $result;
}

//    
 //                      

/**
    *                                                  
    *                                                           
    *                                    
    */
function getSpecialQuery($type)
{
switch ($type) {
case 'tables':
$sql = "select name from sysobjects where type = 'U' order by name";
break;
case 'views':
$sql = "select name from sysobjects where type = 'V'";
break;
default:
return null;
}
return $sql;
}

//    

}

/*
 *                 
 *             
 *                  
 *     
 */
?>
